stages:
  - test
  - build

image: marvinvanaalst/poetry-ci:0.3

prior:
  allow_failure: true
  stage: test
  script:
    - poetry install
    - poetry run isort src/ tests/
    - poetry run black src/ tests/
    - poetry run flake8 src/ tests/
    - poetry run mypy src/ tests/
  except:
    - merge_requests
    - main

test:
  stage: test
  script:
    - poetry install
    - poetry run pytest --disable-warnings --cov
  coverage: "/TOTAL.+ ([0-9]{1,3}%)/"
  only:
    - merge_requests
    - main # if i push directly and for coverage badge

build:
  stage: build
  script:
    - poetry build
    - poetry publish --username "$PYPI_USERNAME" --password "$PYPI_PASSWORD"
  rules:
    - if: $CI_COMMIT_BRANCH == $CI_DEFAULT_BRANCH
      changes:
        - pyproject.toml

pages:
  allow_failure: true
  stage: build
  script:
    - pip install -r docs/requirements.txt
    - mkdocs build --strict --verbose
  artifacts:
    paths:
      - public
  only:
    - main
